context("seq and rep")

# 2007 starts on jan 1st
# 2008 is a leaop year
# 2009 has 53 weeks
# 2010 is a gernic year without special properties


# seq ---------------------------------------------------------------------

test_that("seq.date_yw works", {
  x <- seq(date_yw(2007, 1), date_yw(2010, 52))
  expect_identical(
    as.integer(x),
    c(200701:200752, 200801:200852, 200901:200953, 201001:201052)
  )

  tdat  <- date_yw(c(2002, 2020), c(50, 2))
  tdat2 <- date_yw(c(2002, 2020), c(50, 50))

  expect_identical(
    seq(tdat[1], tdat[2]),
    as_date_yw(seq(as.Date("2002-12-10"), as.Date("2020-01-07"), by = "7 days"))
  )

  expect_identical(
    seq(tdat[1], tdat[2], by = 3),
    as_date_yw(seq(as.Date("2002-12-10"), as.Date("2020-01-07"), by = "21 days"))
  )
})




test_that("seq.date_yq works", {
  x <- as_date_yq(c(20072, 20093))

  expect_identical(
    seq(x[1], x[2]),
    as_date_yq(c(20072:20074, 20081:20084, 20091:20093))
  )

  expect_identical(
    seq(x[1], x[2], by = 2),
    as_date_yq(c(20072L, 20074L, 20082L, 20084L, 20092L))
  )

  expect_identical(
    seq(x[1], x[2], by = 3),
    as_date_yq(c(20072L, 20081L, 20084L, 20093L))
  )

  expect_identical(
    seq(x[1], x[2], by = 4),
    as_date_yq(c(20072L, 20082L, 20092L))
  )

  expect_identical(
    seq(x[1], x[2], by = 5),
    as_date_yq(c(20072L, 20083L))
  )


  # reverse
  expect_identical(
    seq(x[2], x[1], by = 3),
    as_date_yq(rev(c(20072L, 20081L, 20084L, 20093L)))
  )

  # invalid inputs
  expect_error(
    seq(x[2], x[1], by = -3)
  )

  expect_error(
    seq(x[2], x[1], by = 1.2)
  )
})




test_that("seq.date_ym works", {
  x <- as_date_ym(c(200706, 200910))
  eres <- as_date_ym(c(200706:200712, 200801:200812, 200901:200910))

  expect_identical(
    seq(x[1], x[2]),
    eres
  )

  expect_identical(
    seq(x[1], x[2], by = 2),
    eres[c(TRUE, FALSE)]
  )

  expect_identical(
    seq(x[1], x[2], by = 3),
    eres[c(TRUE, FALSE, FALSE)]
  )

  expect_identical(
    seq(x[1], x[2], by = 4),
    eres[c(TRUE, FALSE, FALSE, FALSE)]
  )

  expect_identical(
    seq(x[1], x[2], by = 5),
    eres[c(TRUE, FALSE, FALSE, FALSE, FALSE)]
  )

  # reverse
  expect_identical(
    seq(x[2], x[1], by = 3),
    rev(eres)[c(TRUE, FALSE, FALSE)]
  )

  # invalid inputs
  expect_error(
    seq(x[2], x[1], by = -3)
  )

  expect_error(
    seq(x[2], x[1], by = 1.2)
  )
})




test_that("seq.date_ym works", {
  # test corner cases, normal case are tested above

  expect_error(
    seq_date_xx(
      date_yq(integer(), integer()),
      date_yq(integer(), integer()),
      by = 1,
      base = 4L,
      ctor = date_yq
    ),
    "scalar"
  )

  expect_error(
    seq_date_xx(
      date_yq(NA_integer_, NA_integer_),
      date_yq(2018, 1),
      by = 1,
      base = 4L,
      ctor = date_yq
    ),
    "positive"
  )

  expect_error(
    seq_date_xx(date_yq(-10, 3), date_yq(-8, 2), by = 1, base = 4L, ctor = date_yq),
    "positive"
  )
})




# rep ---------------------------------------------------------------------

test_that("rep.date_xx and min/max work", {

  expect_identical(
    rep(date_yq(2016, 1), 5),
    as_date_yq(rep(20161, 5))
  )

  expect_identical(
    rep(date_ym(2016, 1), times = 5),
    as_date_ym(rep(201601, times = 5))
  )

  expect_identical(
    rep(date_yw(2016, 1:2), each = 5),
    as_date_yw(rep(201601:201602, each = 5))
  )

  expect_true(
    length(rep(date_yq(2016, 1:2), length.out = 6)) == 6
  )

})

context("zoo-compat")


test_that("zoo-compat works as expected", {
  q <- date_yq(2016, 1:4)
  qzoo <- as_yearqtr(q)
  expect_identical(as_yearqtr(qzoo), qzoo)
  expect_equal(as.numeric(qzoo), seq(2016.00, 2016.75, by = 0.25))
  rev <- as_date_yq(qzoo)
  expect_identical(rev, q)

  m <- date_ym(2016, 1:12)
  mzoo <- as_yearmon(m)
  expect_identical(as_yearmon(mzoo), mzoo)
  expect_equal(as.numeric(mzoo), seq(2016.00, 2016 + 11/12, by = 1/12))
  rev <- as_date_ym(mzoo)
  expect_identical(rev, m)

  w <- date_yw(2016, 1:52)
  wzoo <- as_yearweek(w)
  expect_identical(as_yearweek(wzoo), wzoo)
  expect_equal(as.numeric(wzoo), seq(2016.00, 2016 + 51/53, by = 1/53))
  rev <- as_date_yw(wzoo)
  expect_identical(rev, w)
})

context("date_yw")




test_that("as_date_yw behaves as expected", {
    #* @testing get_isoweek

    # from https://en.wikipedia.org/wiki/ISO_week_date
    tdat <- read.csv2(textConnection(
    "2005-01-01; 	2004-W53;
     2005-01-02; 	2004-W53;
     2005-12-31; 	2005-W52;
     2007-01-01; 	2007-W01; 	Both years 2007 start with the same day.
     2007-12-30; 	2007-W52;
     2007-12-31; 	2008-W01;
     2008-01-01; 	2008-W01; 	Gregorian year 2008 is a leap year. ISO year 2008 is 2 days shorter: 1 day longer at the start, 3 days shorter at the end.
     2008-12-28; 	2008-W52; 	ISO year 2009 begins three days before the end of Gregorian 2008.
     2008-12-29; 	2009-W01;
     2008-12-30; 	2009-W01;
     2008-12-31; 	2009-W01;
     2009-01-01; 	2009-W01;
     2009-12-31; 	2009-W53; 	ISO year 2009 has 53 weeks and ends three days into Gregorian year 2010.
     2010-01-01; 	2009-W53;
     2010-01-02; 	2009-W53;
     2010-01-03; 	2009-W53;
     2010-01-04; 	2010-W01;"
    ),
      stringsAsFactors = FALSE,
      header = FALSE
    )


  tdat[[1]] <- as.Date(trimws(as.character(tdat[[1]])))
  tdat[[2]] <- trimws(tdat[[2]])

  expect_identical(
    format(as_date_yw(tdat[[1]])),
    tdat[[2]]
  )

  expect_identical(
    get_isoweek(tdat[[1]]),
    as.integer(substr(tdat[[2]], 7, 8))
  )
})




test_that("format_yw behaves as expected", {
  expect_identical(format_yw(2015, 5), "2015-W05")
  expect_identical(format_yw(201505, format = "%Y.%V"), "2015.05")
  expect_identical(
    format_yw(as_date_yw(201505), format = "%y.%V"),
    "15.05"
  )
})

context("increment")


test_that("increment.date_yq works as expected", {

  x <- as_date_yq(c(14, 101, 212341, 212344, 20151, 20164))

  expect_silent(xp1 <- increment(x, 1))
  expect_silent(xp5 <- increment(x, 5))
  expect_silent(xm1 <- increment(x, -1))
  expect_silent(xm5 <- increment(x, -5))

  expect_identical(xp1, as_date_yq(c(21, 102, 212342, 212351, 20152, 20171)))
  expect_identical(xp5, as_date_yq(c(31, 112, 212352, 212361, 20162, 20181)))
  expect_identical(xm1, as_date_yq(c(13, 94, 212334, 212343, 20144, 20163)))
  expect_identical(xm5, as_date_yq(c(3, 84, 212324, 212333, 20134, 20153)))

})



test_that("increment.date_ym", {

  x <- as_date_ym(c(201212, 201201, 001, -101, 11, 3))

  expect_silent(xp1 <- increment(x, 1))
  expect_silent(xp5 <- increment(x, 5))
  expect_silent(xm1 <- increment(x, -1))
  expect_silent(xm5 <- increment(x, -5))

  expect_identical(xp1, as_date_ym(c(201301, 201202, 2, -102, 12, 4)))
  expect_identical(xp5, as_date_ym(c(201305, 201206, 6, -106, 104, 8)))
  expect_identical(xm1, as_date_ym(c(201211, 201112, -112, -212, 10, 2)))
  expect_identical(xm5, as_date_ym(c(201207, 201108, -108, -208, 6, -110)))
})



test_that("increment.date_y works", {

  x <- as_date_y(c(2012, 2013))

  expect_identical(increment(x, 1), as_date_y(c(2013, 2014)))
  expect_identical(increment(x, -1), as_date_y(c(2011, 2012)))

})

context("date_xx")




test_that("common generics have methods for date_xx", {
  q <- date_yq(2014, c(1, 1, 1, 1:4))
  m <- date_ym(2014, c(1, 1, 1, 1:12))
  w <- date_yw(2014, c(1, 1, 1, 1:52))
  y <- date_y(c(2014, 2014, 2015, 2015, 2015))

  # unique
  expect_identical(unique(q), date_yq(2014, 1:4))
  expect_identical(unique(m), date_ym(2014, 1:12))
  expect_identical(unique(w), date_yw(2014, 1:52))
  expect_identical(unique(y), date_y(2014:2015))
})




test_that("make_date_xx works", {
  expect_identical(make_date_xx(2012), date_y(2012))
  expect_identical(make_date_xx(2012, 4), date_yq(2012, 4))
  expect_identical(make_date_xx(2012, m = 4), date_ym(2012, 4))
})




test_that("print date_xx returns input", {
  expect_output(expect_identical(print(make_date_xx(2012)), make_date_xx(2012)))
})




test_that("date_xx coercion to POSIXt works", {
  expect_identical(as.POSIXlt(make_date_xx(2012)), as.POSIXlt(as.Date("2012-01-01")))
  expect_identical(as.POSIXct(make_date_xx(2012)), as.POSIXct(as.Date("2012-01-01")))
})




test_that("Sys.date_** return the appropriate types", {
  expect_true(is_date_yq(Sys.date_yq()))
  expect_true(is_date_ym(Sys.date_ym()))
  expect_true(is_date_yw(Sys.date_yw()))
})

context("format")


all_tokens <- c("Y:%Y", "y:%y", "b:%b", "B:%B", "m:%m", "q:%q", "%%:%%", "V:%V")



test_that("tokenize_format works as expected", {
  fm <- "Y%Y-y%y-q%q-%%%yY"

  # normal cases
  expect_identical(
    tokenize_format(fm),
    c("Y", "%Y", "-y", "%y", "-q", "%q", "-", "%%", "%y", "Y")
  )

  fm <- "%Y-y%y-q%q-%%y"
  expect_identical(
    tokenize_format(fm),
    c("%Y", "-y", "%y", "-q", "%q", "-", "%%", "y")
  )

  # special cases
  expect_identical(tokenize_format("%y"), "%y")
  expect_identical(tokenize_format("y"), "y")
  expect_identical(tokenize_format(""), "")
  expect_identical(tokenize_format(character()), character())
})





test_that("format date_y works as expected", {
  td <- date_y(2010:2013)
  eres <- c("Y2010-y10-%10Y", "Y2011-y11-%11Y", "Y2012-y12-%12Y", "Y2013-y13-%13Y")

  # normal cases
  expect_identical(format(td, "Y%Y-y%y-%%%yY"), eres)
  expect_identical(format(td, "%Y-y%y-%%%y"), substr(eres, 2, nchar(eres) - 1))

  # special_cases
  expect_identical(format(td, ""), rep("", times = length(td)))
  date0 <- date_y(integer())
  expect_identical(format(date0), character())

  # violated preconditions
  expect_error(format(td, format = character()))
  expect_error(
    format(td, format = paste(all_tokens, collapse = " ")),
    paste(sort(c("%b", "%B", "%m", "%q", "%V")), collapse = ", ")
  )
})




test_that("format.date_yq: All Tokens Work", {
  fmt <- "y:%y Y:%Y q:%q m:%m b:%b B:%B %%:%%"
  q <- date_yq(2005, 1)
  expect_identical(format(q), "2005-Q1")
  expect_identical(
    format(q, fmt, month_names = month.name, month_abb = month.abb),
    "y:05 Y:2005 q:1 m:01 b:Jan B:January %:%"
  )

  # abort on illegal tokens
  fmt <- "%s %F %b"
  q <- date_yq(2005, 1)
  expect_error(format(q, format = paste(all_tokens, collapse = " ")), "%V")
})



test_that("format.date_yq: works for vectors", {
  td <- date_yq(2010:2019, 3)
  eres <- c(
    "Y2010-y10-q3-%%10Y", "Y2011-y11-q3-%%11Y", "Y2012-y12-q3-%%12Y",
    "Y2013-y13-q3-%%13Y", "Y2014-y14-q3-%%14Y", "Y2015-y15-q3-%%15Y",
    "Y2016-y16-q3-%%16Y", "Y2017-y17-q3-%%17Y", "Y2018-y18-q3-%%18Y",
    "Y2019-y19-q3-%%19Y"
  )

  # normal cases
  expect_identical(format(td, "Y%Y-y%y-q%q-%%%%%yY"), eres)
  expect_identical(format(td, "%Y-y%y-q%q-%%%%%y"), substr(eres, 2, nchar(eres) - 1))

  # special_cases
  expect_identical(format(td, ""), rep("", times = length(td)))
  date0 <- date_yq(integer(), integer())
  expect_identical(format(date0), character())

  # violated preconditions
  expect_error(format(td, format = character()))
})



test_that("format.date_yq works for weird dates", {
  tdat <- as_date_yq(c(-104, -11, 1, 12, 103, 1004, 20001, 212342))

  expect_identical(
    format(tdat),
    c("-10-Q4", "-1-Q1", "0-Q1", "1-Q2", "10-Q3", "100-Q4", "2000-Q1",
      "21234-Q2")
  )

  expect_identical(
    format(tdat, "%Y.%q"),
    c("-10.4", "-1.1", "0.1", "1.2", "10.3", "100.4", "2000.1", "21234.2")
  )

  expect_identical(
    format(tdat, "%y.%q"),
    c("-10.4", "-01.1", "00.1", "01.2", "10.3", "00.4", "00.1", "34.2")
  )
})




test_that("format.date_ym: All Tokens Work", {
  fmt <- "y:%y Y:%Y q:%q m:%m b:%b B:%B %%:%%"
  m <- date_ym(2005, 11)
  expect_identical(format(m), "2005-M11")
  expect_identical(
    format(m, fmt, month_names = month.name, month_abb = month.abb),
    "y:05 Y:2005 q:4 m:11 b:Nov B:November %:%"
  )

  # abort on illegal tokens
  expect_error(format(m, format = paste(all_tokens, collapse = " ")), "%V")
})



test_that("format.date_yw: All Tokens Work", {
  fmt <- "y:%y Y:%Y W:%V %%:%%"
  m <- date_yw(2005, 11)
  expect_identical(format(m), "2005-W11")
  expect_identical(
    format(m, fmt, month_names = month.name, month_abb = month.abb),
    "y:05 Y:2005 W:11 %:%"
  )

  # abort on illegal tokens
  expect_error(
    format(m, format = paste(all_tokens, collapse = " ")),
    paste(sort(c("%b", "%B", "%m", "%q")), collapse = ", ")
  )
})




test_that("format.date_ym: month names are formatted correclty", {
  td <- date_ym(2018, c(1L, 10L, 3L, 6L, 4L, 5L, 7L, 12L, 2L, 9L, 8L, 11L))
  fm <- "%Y-M%m: %B,%b"

  tres <- format(
    td,
    format = fm,
    month_names = month.name,
    month_abb = month.abb
  )

  eres <- c(
    "2018-M01: January,Jan", "2018-M10: October,Oct", "2018-M03: March,Mar",
    "2018-M06: June,Jun", "2018-M04: April,Apr", "2018-M05: May,May",
    "2018-M07: July,Jul", "2018-M12: December,Dec", "2018-M02: February,Feb",
    "2018-M09: September,Sep", "2018-M08: August,Aug", "2018-M11: November,Nov"
  )

  expect_identical(eres, tres)
})




test_that("default formats are ISO formats", {
  expect_identical(format(date_ym(2018, 5)),  "2018-M05")
  expect_identical(format(date_yq(2018, 1)),  "2018-Q1")
  expect_identical(format(date_yw(2018, 51)), "2018-W51")
})




test_that("format_y* defaults to iso", {
  d <- as.Date("2018-12-10")
  expect_identical(format_yq(d), "2018-Q4")
  expect_identical(format_ym(d), "2018-M12")
  expect_identical(format_yw(d), "2018-W50")

  d <- as.Date("2018-01-1")
  expect_identical(format_yq_iso(d), format_yq(d))
  expect_identical(format_yq_short(d), "2018.1")
  expect_identical(format_yq_shorter(d), "18.1")

  expect_identical(format_ym_iso(d), format_ym(d))
  expect_identical(format_ym_short(d), "2018.01")
  expect_identical(format_ym_shorter(d), "18.01")

  expect_identical(format_yw_iso(d), format_yw(d))
  expect_identical(format_yw_short(d), "2018.01")
  expect_identical(format_yw_shorter(d), "18.01")
})

context("first_of")



# year --------------------------------------------------------------------

test_that("first_of_year works as expected", {
  # for Date
  expect_identical(
    first_of_year(as.Date("2018-01-03")),
    as.Date("2018-01-01")
  )
  expect_identical(
    last_of_year(as.Date("2018-01-03")),
    as.Date("2018-12-31")
  )

  # for date_xx
  expect_identical(
    first_of_year(date_yq(2018, 2)),
    as.Date("2018-01-01")
  )
  expect_identical(
    last_of_year(date_ym(2018, 1)),
    as.Date("2018-12-31")
  )

  # for numeric years
  expect_identical(
    first_of_year(2018),
    as.Date("2018-01-01")
  )
  expect_identical(
    last_of_year(2018),
    as.Date("2018-12-31")
  )
})



test_that("test first_of_month against lubridate", {
  if (!requireNamespace("lubridate", quietly = TRUE)){
    skip("test requires lubridate")
  }

  tdat <- c(make_date(2000, 1:12, 1), make_date(2002, 1:12, 1))

  expect_identical(
    first_of_year(tdat),
    lubridate::floor_date(tdat, "year")
  )

  expect_identical(
    last_of_year(tdat),
    lubridate::ceiling_date(tdat, "year") - 1
  )
})




# quarter -----------------------------------------------------------------
test_that("first_of_quarter works as expected", {
  expect_identical(
    first_of_quarter(make_date(2000, 1:12, 1)),
    c(
      rep(make_date(2000, 1, 1), 3),
      rep(make_date(2000, 4, 1), 3),
      rep(make_date(2000, 7, 1), 3),
      rep(make_date(2000, 10, 1), 3)
    )
  )

  expect_identical(
    last_of_quarter(make_date(2000, 1:12, 1)),
    c(
      rep(make_date(2000, 3, 31), 3),
      rep(make_date(2000, 6, 30), 3),
      rep(make_date(2000, 9, 30), 3),
      rep(make_date(2000, 12, 31), 3)
    )
  )

  expect_identical(
    unique(first_of_quarter(make_date(2000, 1:12, 1))),
    first_of_yq(2000, 1:4)
  )
  expect_identical(
    last_of_quarter(unique(last_of_quarter(make_date(2000, 1:12, 1)))),
    last_of_yq(2000, 1:4)
  )

  expect_identical(first_of_yq("2004-05-07"), as.Date("2004-04-01"))
  expect_identical(last_of_yq("2004-05-07"), as.Date("2004-06-30"))
})




test_that("test first_of_quarter against lubridate", {
  if (!requireNamespace("lubridate", quietly = TRUE)){
    skip("test requires lubridate")
  }

  tdat <- make_date(2000, 1:12, 1)

  expect_identical(
    first_of_quarter(tdat),
    lubridate::floor_date(tdat, "quarter")
  )
  expect_identical(
    last_of_quarter(tdat),
    lubridate::ceiling_date(tdat, "quarter") - 1
  )
})




# month -------------------------------------------------------------------

test_that("first_of_month works as expected", {
  # first day
  expect_identical(
    first_of_ym(2018, c(4, 12)),
    as.Date(c("2018-04-01", "2018-12-01"))
  )

  expect_identical(
    first_of_ym(2018, c(4, 12)),
    first_of_ym(as.Date(c("2018-04-13", "2018-12-01")))
  )

  # last day
    expect_identical(
      last_of_ym(c(2000, 2004, 2100), 2),
      as.Date(c("2000-02-29", "2004-02-29", "2100-02-28"))
    )

  expect_identical(
    last_of_month(as.Date("2018-05-13")),
    as.Date("2018-05-31")
  )

  expect_identical(
    last_of_ym(as.Date("2018-05-13")),
    last_of_ym(2018, 5)
  )
})




test_that("test first_of_month against lubridate", {
  if (!requireNamespace("lubridate", quietly = TRUE)){
    skip("test requires lubridate")
  }

  tdat <- c(make_date(2000, 1:12, 1), make_date(2002, 1:12, 1))

  expect_identical(
    first_of_month(tdat),
    lubridate::floor_date(tdat, "month")
  )

  expect_identical(
    last_of_month(tdat),
    lubridate::ceiling_date(tdat, "month") - 1
  )
})




# isoweek -----------------------------------------------------------------


test_that("first_of_isoweek works", {
  tdat <- seq(as.Date("2004-12-20"), as.Date("2020-01-06"), by = "7 days")

  expect_equal(
    first_of_isoweek(tdat),
    tdat
  )

  expect_equal(
    last_of_isoweek(tdat),
    tdat + 6L
  )

  expect_equal(
    seq(as.Date("2004-01-05"), as.Date("2004-12-20"), by = "7 days"),
    first_of_yw(2004, 2:52)
  )
  expect_equal(
    seq(as.Date("2004-01-11"), as.Date("2004-12-26"), by = "7 days"),
    last_of_yw(2004, 2:52)
  )

  expect_equal(first_of_yw("2004-01-07"), as.Date("2004-01-05"))
  expect_equal(last_of_yw("2004-01-07"), as.Date("2004-01-11"))
})




test_that("first_of_isoyear works", {
  eres <- data.frame(
    year = c(2018, 2017, 2016, 2005, 2004),
    from = as.Date(c("2018-01-01", "2017-01-02", "2016-01-04", "2005-01-03", "2003-12-29")),
    to   = as.Date(c("2018-12-30", "2017-12-31", "2017-01-01", "2006-01-01", "2005-01-02"))
  )

  expect_identical(
    first_of_isoyear(as_date_y(eres$year)),
    eres$from
  )

  expect_identical(
    first_of_isoyear(date_yw(eres$year, 1L)),
    eres$from
  )

  expect_identical(
    last_of_isoyear(as_date_y(eres$year)),
    eres$to
  )

  expect_identical(
    last_of_isoyear(date_yw(eres$year, 1L)),
    eres$to
  )
})




test_that("first_of_isoweek and first_of_isoyear are consistent", {
  eres <- data.frame(
    year = c(2018, 2017, 2016, 2005, 2004),
    from = as.Date(c("2018-01-01", "2017-01-02", "2016-01-04", "2005-01-03", "2003-12-29")),
    to   = as.Date(c("2018-12-30", "2017-12-31", "2017-01-01", "2006-01-01", "2005-01-02"))
  )

  expect_identical(
    first_of_isoyear(date_yw(eres$year, 1L)),
    first_of_isoweek(date_yw(eres$year, 1L))
  )

  expect_identical(
    first_of_isoweek(date_yw(eres$year, 1L)) + 6L,
    last_of_isoweek(date_yw(eres$year, 1L))
  )
})




test_that("first_of_iso* can handle anything coerciable to date", {
  expect_identical(
    first_of_isoweek("2018-09-07"),
    as.Date("2018-09-03")
  )

  expect_identical(
    last_of_isoweek("2018-09-07"),
    as.Date("2018-09-09")
  )

  expect_identical(
    first_of_isoyear("2016-09-07"),
    as.Date("2016-01-04")
  )

  expect_identical(
    last_of_isoyear("2016-09-07"),
    as.Date("2017-01-01")
  )
})

context("utils")


test_that("utils works as expected", {
  q <- date_yq(2018, 1)
  m <- date_ym(2018, 1)
  w <- date_yw(2018, 1)
  y <- date_y(2018)
  a <- structure("test", class = c("date_yq", "blahblah", "date_xx"))
  b <- structure("test", class = c("date_yq", "date_ym", "date_xx"))

  expect_identical(which_date_xx(q), "date_yq")
  expect_identical(which_date_xx(m), "date_ym")
  expect_identical(which_date_xx(w), "date_yw")
  expect_identical(which_date_xx(y), "date_y")

  expect_identical(which_date_xx(a), "date_yq")
  expect_error(which_date_xx(b))

  # substr_right
  expect_identical(substr_right("blubb", 3), "ubb")
})




test_that("tz works", {
  if (!requireNamespace("lubridate", quietly = TRUE)){
    skip("test requires lubridate")
  }

  expect_identical(tz(Sys.Date()), lubridate::tz(Sys.Date()))
  t <- as.Date(Sys.Date(), tz = "CET")
  expect_identical(tz(t), lubridate::tz(t))
})

context("scale_date_xx")


test_that("scale_date_xx works as expected", {
  if (!requireNamespace("ggplot2", quietly = TRUE)){
    skip("test requires ggplot2")
  }

  # Force all branches of the date_**_breaks and ensure no exception is raised
  # < 6
  tdf <- data.frame(
    yq = date_yq(2000, 1:4),
    ym = date_ym(2000, 4:7),
    yw = date_yw(2000, 21:24),
    vals = runif(4)
  )
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(x = yq, y = vals))))
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(x = ym, y = vals))))
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(x = yw, y = vals))))

  # > 6
  tdf <- data.frame(
    yq = date_yq(c(rep(1990, 4), rep(1991, 4)), c(1:4, 1:4)),
    ym = date_ym(1990, 1:8),
    yw = date_yw(1990, 1:8),
    vals = runif(8)
  )
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(y = yq, x = vals))))
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(y = ym, x = vals))))
  expect_silent(print(ggplot2::ggplot(tdf, ggplot2::aes(y = yw, x = vals))))

  # large
  expect_silent(date_yq_breaks()(date_yq(1950:2021, 1)))
  expect_silent(date_ym_breaks()(date_ym(1990:2021, 1)))

  expect_silent(date_yw_breaks()(date_yw(1910, c(1, 50))))
  expect_silent(date_yw_breaks()(date_yw(1910:2221, 1)))

  expect_silent(date_yq_breaks()(date_yq(NA, NA)))
  expect_silent(date_ym_breaks()(date_ym(NA, NA)))
  expect_silent(date_yw_breaks()(date_yw(NA, NA)))
})



test_that("date_yq_breaks doesnt fail for a variety of inputs", {

  x <- rep(date_yq(2018, 1), 5)
  expect_silent(date_yq_breaks()(x))

  qs <- 1:4
  ys <- 1800:2200
  nas <- c(0, 2, 5)
  pad <- 0:4

  for(i in 1:100){
    y <- sample(ys, 2, replace = TRUE)
    q <- sample(qs, 2, replace = TRUE)
    p <- sample(pad, 2, replace = TRUE)
    na <- sample(nas, 1)
    x <- seq(date_yq(y[[1]], q[[1]]), date_yq(y[[2]], q[[2]]))
    x[sample(1:length(x), na, replace = TRUE)] <- NA
    expect_silent(date_yq_breaks()(x))
  }

  ys <- 2000:2010


  for(i in 1:100){
    y <- sample(ys, 2, replace = TRUE)
    q <- sample(qs, 2, replace = TRUE)
    p <- sample(pad, 2, replace = TRUE)
    na <- sample(nas, 1)
    x <- seq(date_yq(y[[1]], q[[1]]), date_yq(y[[2]], q[[2]]))
    x[sample(1:length(x), na, replace = TRUE)] <- NA
    expect_silent(date_yq_breaks()(x))
  }

  ys <- 2000:2005

  for(i in 1:100){
    y <- sample(ys, 2, replace = TRUE)
    q <- sample(qs, 2, replace = TRUE)
    p <- sample(pad, 2, replace = TRUE)
    na <- sample(nas, 1)
    x <- seq(date_yq(y[[1]], q[[1]]), date_yq(y[[2]], q[[2]]))
    x[sample(1:length(x), na, replace = TRUE)] <- NA
    expect_silent(date_yq_breaks()(x))
  }
})



test_that("date_ym_breaks doesnt fail for a variety of inputs", {
  skip("not yet")
  x <- date_ym(2018, 1:12)
  date_ym_breaks()(x)
})




test_that("date_ym_trans is reversible", {

  if (!requireNamespace("scales", quietly = TRUE)){
    skip("test requires scales")
  }

  x <- seq(date_ym(1950, 1), date_ym(2050, 1))
  trn <- date_ym_trans$transform(x)
  inv <- date_ym_trans$inverse(trn)
  expect_identical(x, inv)
})

context("accessors")


test_that("get_* returns integers", {
  d <- Sys.Date()
  ym <- date_ym(2018, 1)
  yq <- date_yq(2018, 1)
  y <-  date_y(2018)

  expect_true(is.integer(get_month(d)))
  expect_true(is.integer(get_month(ym)))
  expect_true(is.integer(get_month(yq)))

  expect_true(is.integer(get_quarter(d)))
  expect_true(is.integer(get_quarter(ym)))
  expect_true(is.integer(get_quarter(yq)))

  expect_true(is.integer(get_year(d)))
  expect_true(is.integer(get_year(ym)))
  expect_true(is.integer(get_year(yq)))

  expect_error(get_month(y))
  expect_error(get_quarter(y))
})



test_that("lubridate accessors work", {
  if (!requireNamespace("lubridate", quietly = TRUE)){
    skip("test requires lubridate")
  }
  ym <- date_ym(2018, 1)
  expect_identical(lubridate::year(ym), get_year(ym))
  expect_identical(lubridate::month(ym), get_month(ym))
  expect_identical(lubridate::quarter(ym), get_quarter(ym))
})

context("arithmetic")


test_that("range.date_xx and min/max work", {
  q <- date_yq(2014, c(1, 1, 1, 1:4))
  m <- date_ym(2014, c(1, 1, 1, 1:12))
  w <- date_yw(2014, c(1, 1, 1, 1:52))
  y <- date_y(c(2014, 2014, 2015, 2015, 2015))

  expect_identical(range(q), date_yq(2014, c(1, 4)))
  expect_identical(range(m), date_ym(2014, c(1, 12)))
  expect_identical(range(w), date_yw(2014, c(1, 52)))
  expect_identical(range(y), date_y(2014:2015))

  expect_identical(min(q), date_yq(2014, 1))
  expect_identical(max(q), date_yq(2014, 4))

  expect_error(
    max(date_yq(2014, 1), date_ym(2014, 5)),
    "subclass"
  )
})




test_that("round.date_xx works", {

  x <- date_yq(2018, 1:4)

  expect_identical(floor(x), date_yq(2018, c(1, 1, 1, 1)))
  expect_identical(ceiling(x), date_yq(2019, c(1, 1, 1, 1)))
  expect_identical(round(x), date_yq(c(2018, 2018, 2019, 2019), 1))

  x <- date_ym(2018, 1:12)

  expect_identical(floor(x), date_ym(2018, rep(1, 12)))
  expect_identical(ceiling(x), date_ym(2019, rep(1, 12)))
  expect_identical(round(x), date_ym(c(rep(2018, 6), rep(2019, 6)), 1))

  x <- date_yw(2018, 1:53)

  expect_identical(floor(x), date_yw(2018, rep(1, 53)))
  expect_identical(ceiling(x), date_yw(2019, rep(1, 53)))
  expect_identical(round(x), date_yw(c(rep(2018, 26), rep(2019, 27)), 1))
})



test_that("comparison ops work", {
  for (ctor in list(date_yq, date_ym, date_yw)){
    for (op in list(`<`, `>`, `==`, `!=`, `<=`, `>=`)){
      q1 <- ctor(2014, 1)
      q2 <- ctor(2015, 1)
      expect_identical(op(q1, q2), op(as.integer(q1), as.integer(q2)))
      expect_identical(op(q1, q1), op(as.integer(q1), as.integer(q1)))
      expect_identical(op(q1, as.integer(q2)), op(as.integer(q1), as.integer(q2)))
      expect_identical(op(q1, as.integer(q1)), op(as.integer(q1), as.integer(q1)))
      expect_error(op(q1, as_date_y(q1)))
    }
  }
})




test_that("y+.date_ym works", {
  expect_identical(
    date_ym(2017, 1) %y+% 1,
    date_ym(2018, 1)
  )

  expect_identical(
    date_ym(2017, 1) %y-% 1,
    date_ym(2016, 1)
  )
})




test_that("y+.date_yq arithmetic works", {
  expect_identical(
    date_yq(2017, 1) %y+% 1,
    date_yq(2018, 1)
  )

  expect_identical(
    date_yq(2017, 1) %y-% 1,
    date_yq(2016, 1)
  )
})




test_that("+ works for date_xx", {
  expect_identical(
    date_yq(2017, 4) + 1,
    date_yq(2018, 1)
  )

  expect_identical(
    date_ym(2017, 12) + 1,
    date_ym(2018, 1)
  )

  expect_identical(
    date_yw(2017, 52) + 1:52,
    date_yw(2018, 1:52)
  )
})



test_that("- works for two date_xx", {

  for(i in 1:100){
    x <- random_date_xx(2, "date_yq")
    diff <- x[[1]] - x[[2]]
    sequence <- seq(x[[1]], x[[2]])
    expect_identical(abs(diff), length(sequence) - 1L)
    expect_identical(x[[2]] + diff, x[[1]])
  }


  for(i in 1:100){
    x <- random_date_xx(2, "date_ym")
    diff <- x[[1]] - x[[2]]
    sequence <- seq(x[[1]], x[[2]])
    expect_identical(abs(diff), length(sequence) - 1L)
    expect_identical(x[[2]] + diff, x[[1]])
  }

  for(i in 1:100){
    x <- random_date_xx(2, "date_yw")
    diff <- x[[1]] - x[[2]]
    sequence <- seq(x[[1]], x[[2]])
    expect_identical(abs(diff), length(sequence) - 1L)
    expect_identical(x[[2]] + diff, x[[1]])
  }


})







test_that("scalar dates are recycled for simple arithmethic operations (#5)",  {
  expect_identical(date_yq(2020, 1) + 2:4, as_date_yq(c(20203L, 20204L, 20211L)))
  expect_identical(date_yq(2020, 3) - 2:4, as_date_yq(c(20201L, 20194L, 20193L)))

  expect_identical(date_ym(2020, 1) + 2:4, as_date_ym(c(202003L, 202004L, 202005L)))
  expect_identical(date_ym(2020, 3) - 2:4, as_date_ym(c(202001L, 201912L, 201911L)))

  expect_identical(date_yw(2020, 1) + 2:4, as_date_yw(c(202003L, 202004L, 202005L)))
  expect_identical(date_yw(2020, 3) - 2:4, as_date_yw(c(202001L, 201952L, 201951L)))

  # only recyle if date is length 1 or equal length with the subtract vector
  expect_error(date_yw(2020, 2:5) - 2:3)
})

context("predicates")


test_that("quarter_bounds works as expected", {

  yqs <- date_yq(2018, 1:4)

  tdat <- data.frame(
    start = c(first_of_quarter(yqs), as.Date(c("2018-03-31", "2018-02-14"))),
    end   = c(last_of_quarter(yqs), as.Date(c("2018-01-01", "2018-02-14")))
  )

  expect_identical(
    is_first_of_quarter(tdat$start),
    c(TRUE, TRUE, TRUE, TRUE, FALSE, FALSE)
  )

  expect_identical(
    is_last_of_quarter(tdat$end),
    c(TRUE, TRUE, TRUE, TRUE, FALSE, FALSE)
  )

  expect_identical(
    is_quarter_bounds(tdat$start, tdat$end),
    c(TRUE, TRUE, TRUE, TRUE, FALSE, FALSE)
  )
})



test_that("year_bounds", {

  yqs <- first_of_year(2018)

  tdat <- data.frame(
    start = c(as.Date(c("2018-01-01", "2018-01-01", "2018-01-01", "2018-02-01"))),
    end   = c(as.Date(c("2018-01-01", "2018-12-31", "2019-12-31", "2018-04-05")))
  )

  expect_identical(
    is_first_of_year(tdat$start),
    c(TRUE, TRUE, TRUE, FALSE)
  )

  expect_identical(
    is_last_of_year(tdat$end),
    c(FALSE, TRUE, TRUE, FALSE)
  )

  expect_identical(
    is_year_bounds(tdat$start, tdat$end),
    c(FALSE, TRUE, FALSE, FALSE)
  )
})


test_that("is_POSIXlt", {
expect_true(is_POSIXlt(as.POSIXlt(Sys.Date())))
})

context("date_yq")


test_that("date_yq ctor works as expected", {
  expect_silent(tr1 <- date_yq(2015, 2))
  expect_true(is.na(date_yq(2015, NA)))
  expect_true(is.na(date_yq(NA, 4)))
  expect_true(is.na(date_yq(NA, NA)))

  expect_identical(as.Date(tr1), as.Date('2015-04-01'))
  expect_identical(as.Date(tr1), as.Date('2015-04-01'))

  tr2 <- as_date_yq(20152)
  expect_identical(tr1, tr2)

  tr3 <- as_date_yq(as.Date('2015-05-02'))
  expect_identical(tr1, tr3)

  expect_identical(
    date_yq(0, 1),
    structure(1L, class = c("date_yq", "date_xx", "integer"))
  )

  expect_identical(
    date_yq(-1, 1),
    structure(-11L, class = c("date_yq", "date_xx", "integer"))
  )

  expect_error(date_yq(0, -1))
})


test_that("as_date_yq works", {
  tdat <- c(-104, -11, 1, 12, 103, 1004, 20001, 212342)

  expect_error(as_date_yq(-1))
  expect_silent(
    tres <- as_date_yq(tdat)
  )

  expect_identical(as.integer(tres), as.integer(tdat))
})





test_that("as_date_yq arithmetic works", {
  #* @testing increment.date_yq
  tdat <- (as_date_yq(c(-11, -12, -13, -14, 1, 2, 3, 4)))

  expect_identical(
    tdat + 1,
    as_date_yq(c(-12, -13, -14, 1, 2, 3, 4, 11))
  )

  expect_identical(
    tdat + 5,
    as_date_yq(c(2, 3, 4, 11, 12, 13, 14, 21))
  )

  expect_identical(
    tdat - 1,
    as_date_yq(c(-24, -11, -12, -13, -14, 1, 2, 3))
  )

  expect_identical(
    tdat - 5,
    as_date_yq(c(-34, -21, -22, -23, -24, -11, -12, -13))
  )


  expect_identical(
    date_yq(2017, 1) %y+% 1,
    date_yq(2018, 1)
  )

  expect_identical(
    date_yq(2017, 1) %y-% 1,
    date_yq(2016, 1)
  )
})

context("parser")


test_that("yq/qy work as expected", {

  x <- c("dfw2018q2", "bl2017qasdg4sadgfas", "201712", "blubb", "2017-2016", NA)
  expect_warning(r <- as.integer(yq(x)), "3 failed")

  expect_identical(
    r,
    c(20182L, 20174L, NA_integer_, NA_integer_, NA_integer_, NA_integer_)
  )


  x <- c("d2fw2018", "b4l2017", "122017", "blubb", "2017-2016", NA)

  expect_warning(r <- as.integer(qy(x)), "3 failed")

  expect_identical(
    r,
    c(20182L, 20174L, NA_integer_, NA_integer_, NA_integer_, NA_integer_)
  )

  expect_identical(qy("stpQ42015"), dint::date_yq(2015, 4))
  expect_identical(yq("stp20154"), dint::date_yq(2015, 4))
})





test_that("ym/my work as expected", {

  x <- c("dfw2018m02", "bl2017qasdg12sadgfas", "2017Q4", "blubb", "2017-2016", NA, "gvship_ais_2019-M10.fst")

  expect_warning(
    r <- as.integer(ym(x)),
    "3 failed"
  )

  expect_identical(
    r,
    c(201802L, 201712L, NA_integer_, NA_integer_, NA_integer_, NA_integer_, 201910L)
  )


  x <- c("d02fw2018", "b122017", "42017", "blubb", "2017-2016", NA)

  expect_warning(
    r <- as.integer(my(x)),
    "3 failed"
  )

  expect_identical(
    r,
    c(201802L, 201712L, NA_integer_, NA_integer_, NA_integer_, NA_integer_)
  )

  expect_identical(my("stpm042015"), dint::date_ym(2015, 4))
  expect_identical(ym("stpm201504"), dint::date_ym(2015, 4))
})

---
title: "Untitled"
output: html_document
editor_options: 
  chunk_output_type: console
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
library(ggplot2)
library(dint)
```


```{r}

dd <- data.frame(
  date = seq(date_yq(2012, 4), date_yq(2018, 4)),
  V1 = 1:25
)

ggplot(
  dd,
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq(breaks = date_yq_breaks(3)) 


ggplot(
  dd[get_year(dd$date) %in% 2014, ],
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

```



## print each quarter

```{r}

ggplot(
  dd[get_year(dd$date) %in% 2013, ],
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  dd[get_year(dd$date) %in% 2013:2014, ],
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()


```


## scale arguments

```{r}

  p <- ggplot(
    dd,
    aes(
      x = date,
      y = V1
    )
  ) + 
    geom_point() 
  
  p + scale_x_date_yq(labels = waiver()) + ggtitle("auto Labels")
  p + scale_x_date_yq(labels = NULL) + ggtitle("no Labels")
  p + scale_x_date_yq(breaks = date_yq(2016, 2:3), labels = LETTERS[1:2] ) + ggtitle("manual Labels")
  p + scale_x_date_yq(labels = format_yq_iso) + ggtitle("function Labels")
  
  p + scale_x_date_yq(breaks = waiver()) + ggtitle("auto breaks")
  p + scale_x_date_yq(breaks = NULL) + ggtitle("no breaks")
  p + scale_x_date_yq(breaks = date_yq(2016, 2:3) ) + ggtitle("manual breaks")
  p + scale_x_date_yq(breaks = date_yq_breaks(4) ) + ggtitle("function breaks")



```

## Print every second quarter

```{r}

ggplot(
  data.frame(
    date = seq(date_yq(2016, 1), date_yq(2018, 1)),
    V1 = 1:9
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  data.frame(
    date = seq(date_yq(2016, 2), date_yq(2019, 2)),
    V1 = 1:13
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  data.frame(
    date = seq(date_yq(2016, 3), date_yq(2019, 3)),
    V1 = 1:13
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  data.frame(
    date = seq(date_yq(2016, 4), date_yq(2018, 4)),
    V1 = 1:9
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

```



## Print long time series

```{r}

ggplot(
  data.frame(
    date = seq(date_yq(2013, 2), date_yq(2018, 3)),
    V1 = 1
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  data.frame(
    date = seq(date_yq(2013, 4), date_yq(2018, 1)),
    V1 = 1
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()

ggplot(
  data.frame(
    date = seq(date_yq(1990, 4), date_yq(2018, 1)),
    V1 = 1
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()


ggplot(
  data.frame(
    date = seq(date_yq(1950, 4), date_yq(2018, 1)),
    V1 = 1
  ),
  aes(
    x = date,
    y = V1
  )
) + 
  geom_point() +
  scale_x_date_yq()


```


# date_ym

```{r}
dd <- data.frame(
  date = seq(date_ym(1950, 1), date_ym(2018, 11)),
  V1 = 1
)

ggplot(
  dd,
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_ym()



ggplot(
  dd[600:700, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_ym()


ggplot(dd[1:3, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_ym()


ggplot(dd[1:12, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_ym(breaks = date_ym_breaks(12))

ggplot(dd[1:22, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_ym(breaks = date_ym_breaks())


date_ym_breaks()(dd[1:3, ]$date)

```



# date_ym

```{r}
dd <- data.frame(
  date = seq(date_yw(1950, 1), date_yw(2018, 11)),
  V1 = 1
)

ggplot(
  dd,
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw()



ggplot(
  dd[600:700, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw()


ggplot(dd[1:3, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw()


ggplot(dd[1:12, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw(breaks = date_yw_breaks(12))

ggplot(dd[1:22, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw(breaks = date_yw_breaks())

ggplot(dd[1:53, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw(breaks = date_yw_breaks())

ggplot(dd[1:93, ],
  aes(
    x = date,
    y = V1
  )
) +
  geom_point() +
  scale_x_date_yw(breaks = date_yw_breaks())



date_yw_breaks()(dd[1:3, ]$date)

```
